#define _GNU_SOURCE 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <fitsio.h>
#include "SpiceUsr.h"

extern  void plbore_( SpiceDouble [], SpiceDouble [], SpiceInt *, SpiceInt *, SpiceDouble [], SpiceBoolean *);
extern  void nthpun_( SpiceInt *, SpiceDouble []);
extern  void pltidx_( SpiceInt *, SpiceInt *, SpiceInt *);
extern  void bid2dx_( SpiceInt *, SpiceInt *);

void get_plbore (
        SpiceDouble SC_pos_bd[], //input
        SpiceDouble solar_pos_bd[],
        SpiceDouble bsight_bd[],
        SpiceInt *PLID_ptr, //output
        SpiceInt *BODY_ptr,
        SpiceDouble surface_point[],
        SpiceDouble plnorm[],
        SpiceDouble *incidence,
        SpiceDouble *emission,
        SpiceDouble *phase,
        SpiceBoolean *lightened, //eɂȂĂȂtrue
        SpiceBoolean *found //Ƀfture
        )
{
  SpiceBoolean found1;
  SpiceDouble surface_point_tmp[3];
  SpiceDouble SC_pos_bd_d[3], solar_pos_bd_d[3];
  SpiceInt    PLID;
  SpiceInt    PLDEX;
  SpiceInt    BODY;
  SpiceInt    BODIDX;


  plbore_ ( SC_pos_bd, bsight_bd, PLID_ptr, BODY_ptr, surface_point, &found1 );
  
  if (failed_c() || !found1) { //ɃfȂ
    reset_c();
    *found = SPICEFALSE;
    *lightened = SPICEFALSE;
  } else { //Ƀf
    bid2dx_( BODY_ptr, &BODIDX);
    pltidx_( PLID_ptr, &BODIDX, &PLDEX);
    nthpun_( &PLDEX, plnorm);
    vsub_c (solar_pos_bd,surface_point,solar_pos_bd_d);
    vsub_c (SC_pos_bd,surface_point,SC_pos_bd_d);
    *incidence = vsep_c(solar_pos_bd_d,plnorm);
    *emission = vsep_c(SC_pos_bd_d,plnorm);
    *phase = vsep_c(SC_pos_bd_d,solar_pos_bd_d);
    plbore_ ( surface_point, solar_pos_bd_d, &PLID, &BODY, surface_point_tmp, &found1 );
    
    if (!found1 && *incidence > 0 && *incidence*dpr_c() < 90 ) {
      *found = SPICETRUE;
      *lightened = SPICETRUE; //eɂȂĂȂ
    } else {
      *found = SPICETRUE;
      *lightened = SPICEFALSE; //eɂȂĂ
    }
  }
}
