#define _GNU_SOURCE 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <fitsio.h>
#include "SpiceUsr.h"
#define  STRLEN 100
#define  BCVLEN 5       //max number of FOV bound vectors
#define  DISTANCE 100
#define  SOLAR_DISTANCE 100

extern  void rdplat_( SpiceChar [], SpiceInt);
extern  void plbore_( SpiceDouble [], SpiceDouble [], SpiceInt *, SpiceInt *, SpiceDouble [], SpiceBoolean *);
extern  void nthpun_( SpiceInt *, SpiceDouble []);
extern  void nthalb_( SpiceInt *, SpiceInt *, SpiceDouble *);
extern  void pltidx_( SpiceInt *, SpiceInt *, SpiceInt *);
extern  void bid2dx_( SpiceInt *, SpiceInt *);

int ONC_getlos_c ( SpiceInt        instid,
                   SpiceDouble     pixel[2],
                   SpiceDouble     los_vector [3] );
double hapke(double i, double e, double g);
void get_plbore (
        SpiceDouble SC_pos_bd[], //input
        SpiceDouble solar_pos_bd[],
        SpiceDouble bsight_bd[],
        SpiceInt *PLID_ptr, //output
        SpiceInt *BODY_ptr,
        SpiceDouble surface_point[],
        SpiceDouble plnorm[],
        SpiceDouble *incidence,
        SpiceDouble *emission,
        SpiceDouble *phase,
        SpiceBoolean *lightened, //eɂȂĂȂtrue
        SpiceBoolean *found //Ƀfture
        );
int get_cam_info (
        SpiceInt        instid,
        SpiceDouble     center[2],
        SpiceDouble     pixels[2] );

int main(int argc, char *argv[]) {
  
  // general purpose variables
  SpiceChar   instr[STRLEN];
  SpiceDouble    pixel_dbl[2];
  SpiceDouble    image_size[2];
  SpiceDouble    image_center[2];
  SpiceInt    address;
  SpiceBoolean found, lightened;
  
  // fits related variables
  fitsfile *range_fptr, *incidence_fptr, *emission_fptr, *phase_fptr;
  fitsfile *lat_fptr, *lon_fptr, *albedo_fptr, *hapke_fptr, *strike_fptr;
  int dim = 2;
  long int naxis[2];
  long int pixel[2];
  int status = 0;
  
  // output files related
  double *range_img, *incidence_img, *emission_img, *phase_img;
  double *lat_img, *lon_img, *albedo_img, *hapke_img, *strike_img;
  SpiceChar   incidence_fname[STRLEN],range_fname[STRLEN],phase_fname[STRLEN];
  SpiceChar   emission_fname[STRLEN], lat_fname[STRLEN], lon_fname[STRLEN];
  SpiceChar   albedo_fname[STRLEN], hapke_fname[STRLEN], strike_fname[STRLEN];
  SpiceChar   base_fname_1[STRLEN];
  SpiceChar   base_fname_2[STRLEN];
  
  SpiceDouble incidence,emission;
  SpiceDouble phase,range,radius;
  SpiceDouble lat,lon;
  
  double hapke_sum = 0;
  
  SpiceDouble SC_pos_bd[3],solar_pos_bd[3],SC_pos_bdm[3];
  SpiceDouble SC_pos_hp[3];
  SpiceDouble SC_pos_bd_d[3],solar_pos_bd_d[3],earth_pos_bd_d[3];
  SpiceDouble rotate_x,rotate_y,rotate_z;
  SpiceDouble SC_lat,SC_lon;
  SpiceDouble solar_lat,solar_lon;
  SpiceDouble et,lt;
  
  SpiceInt         instid = -130903; //instrument NAIF ID Ƃ肠AMICA ideal
  SpiceBoolean     sc_mode; //FALSE: Psuedo Parallel (LAT/LON), TRUE: refer Spk
  SpiceBoolean     sun_mode; //FALSE: LAT/LON, TRUE: refer Spk
  
  //getfov_c releted variables
  SpiceChar        shape  [STRLEN];
  SpiceChar        frame  [STRLEN]; //name of frame that FOV/boresight are defined.
  SpiceDouble      bsight [3]; //boresight vector
  SpiceInt         n_bcv; //number of FOV bound vectors
  SpiceDouble      bounds [BCVLEN][3];
  
  SpiceDouble      bsight_bd [3]; //boresight vector
  
  SpiceDouble rotate[3][3];
  SpiceDouble rotate_inv[3][3];
  SpiceDouble rotate_cam[3][3];
  
  SpiceDouble plnorm[3];
  SpiceInt    PLID;
  SpiceInt    PLDEX;
  SpiceInt    BODY;
  SpiceInt    BODIDX;
  SpiceDouble albedo;
  SpiceDouble surface_point[3];
  SpiceDouble lon2,lat2,distan;

  SpicePlane image_plane;
  SpiceDouble origin[3] = {0,0,0};
  
  rdplat_( argv[1] , STRLEN);
  printf("%s is loaded.\n",argv[1]);
  --argc;
  ++argv;
  
  while (argc > 1) {
    furnsh_c (argv[1]);
    printf("%s is loaded.\n",argv[1]);
    --argc;
    ++argv;
  }
  
  prompt_c ( "Instrument ID: ", STRLEN, instr );
  instid = (SpiceInt)atoi (instr);
    if (!get_cam_info (instid, image_center, image_size)) {
    printf("Camera %d is not found.\n",instid);
    exit(0);
  }
  naxis[0] = (long int)image_size[0];
  naxis[1] = (long int)image_size[1];
  //AMICÃ{ATCgxNgget
  getfov_c ( instid, BCVLEN, STRLEN, STRLEN,
          shape, frame,  bsight, &n_bcv, bounds );
  nvp2pl_c(bsight, origin, &image_plane);
      
  //Prepare large buffer
  range_img     = (double *)malloc(sizeof(double)*naxis[0]*naxis[1]);
  incidence_img  = (double *)malloc(sizeof(double)*naxis[0]*naxis[1]);
  emission_img  = (double *)malloc(sizeof(double)*naxis[0]*naxis[1]);
  phase_img  = (double *)malloc(sizeof(double)*naxis[0]*naxis[1]);
  lat_img  = (double *)malloc(sizeof(double)*naxis[0]*naxis[1]);
  lon_img  = (double *)malloc(sizeof(double)*naxis[0]*naxis[1]);
  albedo_img  = (double *)malloc(sizeof(double)*naxis[0]*naxis[1]);
  hapke_img  = (double *)malloc(sizeof(double)*naxis[0]*naxis[1]);
  strike_img  = (double *)malloc(sizeof(double)*naxis[0]*naxis[1]);
  
  //Prepare base filename
  prompt_c ( "Base filename: ", STRLEN, base_fname_1 );
  
  while (1) {
	printf("\n");
    prompt_c ( "S/C Mode\n[psuedo parallel projection (LAT/LON):0]\n[Reproduction mode (refer Spk):1]\n> ",
            STRLEN, instr );
    sc_mode = (SpiceBoolean)atoi (instr);
    prompt_c ( "Sun Mode\n[sub-solar LAT/LON:0]\n[Reproduction (refer Spk):1]\n> ",
            STRLEN, instr );
    sun_mode = (SpiceBoolean)atoi (instr);
    if (!sc_mode && sun_mode) {
      printf("This conbination is not allowed.\n");
      exit(0);
    }
    
    
    if (sc_mode) {
      prompt_c ( "Input start time (UTC): ", STRLEN, instr );
      str2et_c (instr,&et);
      timout_c ( et, "YYYY-MM-DDTHRMNSC::UTC", STRLEN, base_fname_2 );
      
      //etɂHAYBUSA猩ITOKAWÄʒu߁CvminusŔ]
      spkpos_c ( "2025143",    et,   "ITOKAWA_FIXED",  "LT+S",
              "-130",  SC_pos_bd,  &lt);
      vminus_c (SC_pos_bd,SC_pos_bd);
      
      //ϑ@WnITOKAWA Body-Fixedւ̕ϊs
      pxform_c ( frame,"ITOKAWA_FIXED", et, rotate);
      
    } else {
      
      prompt_c ( "sub-S/C lat: ", STRLEN, instr );
      SC_lat = atof (instr) * rpd_c();
      prompt_c ( "sub-S/C lon: ", STRLEN, instr );
      SC_lon = atof (instr) * rpd_c();
      latrec_c ( DISTANCE, SC_lon, SC_lat, SC_pos_bd );
      sprintf(base_fname_2, "%3.2f_%3.2f",SC_lat*dpr_c(),SC_lon*dpr_c());
      
      vminus_c(SC_pos_bd,SC_pos_bdm);
      rotate_z = 0;
      rotate_y = -atan2 ((double) SC_pos_bdm[0], (double) SC_pos_bdm[2]);
      rotate_x = atan2 ((double) SC_pos_bdm[1],
              sqrt(SC_pos_bdm[2]*SC_pos_bdm[2]+SC_pos_bdm[0]*SC_pos_bdm[0]));
      eul2m_c (     rotate_z,  rotate_y,  rotate_x, 3,   2,   1,   rotate );  
      
    }
    
    if (sun_mode) {
      //et-ltietHAYBUSAɓ͂ITOKAWA甭鎞jɂ
      //ITOKAWAł̌̑zʒu
      spkpos_c ( "SUN",    et-lt,   "ITOKAWA_FIXED",  "LT+S",
              "2025143",  solar_pos_bd,  &lt);
    } else {
      prompt_c ( "sub-Solar lat: ", STRLEN, instr );
      solar_lat = atof (instr) * rpd_c();
      prompt_c ( "sub-Solar lon: ", STRLEN, instr );
      solar_lon = atof (instr) * rpd_c();
      latrec_c ( SOLAR_DISTANCE, solar_lon, solar_lat, solar_pos_bd );
    }
    
    printf ("S/C position (Body-Fixed):\n");
    printf ( "    X   = %16.5f\n", SC_pos_bd[0]);
    printf ( "    Y   = %16.5f\n", SC_pos_bd[1]);
    printf ( "    Z   = %16.5f\n", SC_pos_bd[2]);
    printf ("Solar position (Body-Fixed):\n");
    printf ( "    X   = %16.5f\n", solar_pos_bd[0]);
    printf ( "    Y   = %16.5f\n", solar_pos_bd[1]);
    printf ( "    Z   = %16.5f\n", solar_pos_bd[2]);
    
    mxv_c (rotate,bsight,bsight);
    printf ( "The central LOS vector (body-fixed):\n");
    printf ( "    X   = %16.5f\n", bsight[0]);
    printf ( "    Y   = %16.5f\n", bsight[1]);
    printf ( "    Z   = %16.5f\n", bsight[2]);
    
	invert_c (rotate, rotate_inv);
    
    //Prepare file name
    sprintf(range_fname, "%s_%s_range.fits",base_fname_1,base_fname_2);
    sprintf(incidence_fname, "%s_%s_i.fits",base_fname_1,base_fname_2);
    sprintf(emission_fname, "%s_%s_e.fits",base_fname_1,base_fname_2);
    sprintf(phase_fname, "%s_%s_g.fits",base_fname_1,base_fname_2);
    sprintf(lat_fname, "%s_%s_lat.fits",base_fname_1,base_fname_2);
    sprintf(lon_fname, "%s_%s_lon.fits",base_fname_1,base_fname_2);
    sprintf(hapke_fname, "%s_%s_hapke.fits",base_fname_1,base_fname_2);
    sprintf(albedo_fname, "%s_%s_a.fits",base_fname_1,base_fname_2);
    sprintf(strike_fname, "%s_%s_s.fits",base_fname_1,base_fname_2);
    
    //Open output files
    if (fits_create_file(&range_fptr, range_fname, &status) != 0) {
      printf("file open error!\n");
      exit(status);
    }
    if (fits_create_file(&incidence_fptr, incidence_fname, &status) != 0) {
      printf("file open error!\n");
      exit(status);
    }
    if (fits_create_file(&emission_fptr, emission_fname, &status) != 0) {
      printf("file open error!\n");
      exit(status);
    }
    if (fits_create_file(&phase_fptr, phase_fname, &status) != 0) {
      printf("file open error!\n");
      exit(status);
    }
    if (fits_create_file(&lat_fptr, lat_fname, &status) != 0) {
      printf("file open error!\n");
      exit(status);
    }
    if (fits_create_file(&lon_fptr, lon_fname, &status) != 0) {
      printf("file open error!\n");
      exit(status);
    }
    if (fits_create_file(&albedo_fptr, albedo_fname, &status) != 0) {
      printf("file open error!\n");
      exit(status);
    }
    if (fits_create_file(&hapke_fptr, hapke_fname, &status) != 0) {
      printf("file open error!\n");
      exit(status);
    }
    if (fits_create_file(&strike_fptr, strike_fname, &status) != 0) {
      printf("file open error!\n");
      exit(status);
    }
    
    
    //plborẽG[΍
    erract_c ("SET",STRLEN,"RETURN");
    
    for (pixel[1] = 0; pixel[1] < naxis[1]; ++pixel[1]) {
      if(!(pixel[1]%100)) {
        printf ( "\rline: %d", pixel[1]);
        fflush(NULL);
      }
      for (pixel[0] = 0; pixel[0] < naxis[0]; ++pixel[0]) {
        
        pixel_dbl[0] = (SpiceDouble)pixel[0];
        pixel_dbl[1] = (SpiceDouble)pixel[1];
        ONC_getlos_c (instid, pixel_dbl, bsight);
        
        //address of the pixel in the image array
        address = pixel[1]*naxis[0] + pixel[0]; 
        
        mxv_c (rotate,bsight,bsight_bd);
        get_plbore ( SC_pos_bd, solar_pos_bd, bsight_bd,
                &PLID, &BODY, surface_point, plnorm,
                &incidence, &emission, &phase,
                &lightened, //eɂȂĂȂtrue
                &found //Ƀfture
                );
        
        if (!found) { //ɃfȂ
          range_img[address] = (double)(0.0);
          incidence_img[address] = (double)(180.0);
          emission_img[address] = (double)(180.0);
          phase_img[address] = (double)(180.0);
          lat_img[address] = (double)(-1.0);
          lon_img[address] = (double)(-1.0);
          albedo_img[address] = (double)(0.0);
          hapke_img [address] = 0.0;
          strike_img [address] = 0.0;
        }
        
        if (found) {
          bid2dx_( &BODY, &BODIDX);
          pltidx_( &PLID, &BODIDX, &PLDEX);
          nthalb_( &PLDEX, &PLID, &albedo);
          reclat_c ( surface_point, &distan, &lon, &lat);
          lat =   dpr_c()*lat;
          lon =   dpr_c()*lon;
          if (lon < 0) lon += 360.00;
          range = vdist_c(SC_pos_bd,surface_point);
          range_img[address] = (double)(range - 99.0)*1000; // meters
          incidence_img[address] = (double)dpr_c()*incidence;
          emission_img[address] = (double)dpr_c()*emission;
          phase_img[address] = (double)dpr_c()*phase;
          lat_img[address] = (double)lat;
          lon_img[address] = (double)lon;
          albedo_img[address] = (double)albedo;
          
		  mxv_c (rotate_inv,plnorm,plnorm);
          vprjp_c (plnorm, &image_plane, plnorm);
		  strike_img[address] = (double)dpr_c()*atan2(plnorm[1],plnorm[0]);
		  
          if (!lightened) { //ɃfCłe
            hapke_img [address] = 0.0;
          } else {
            hapke_img [address] = hapke ((double)dpr_c()*incidence, 
                    (double)dpr_c()*emission, (double)dpr_c()*phase);
          }
        }
      }
    }
    //Output fits files
    fits_create_img(range_fptr, DOUBLE_IMG, dim, naxis, &status);
    fits_write_2d_dbl(range_fptr, 0, naxis[0], naxis[0], naxis[1], range_img, &status);
    fits_close_file(range_fptr, &status);
    
    fits_create_img(incidence_fptr, DOUBLE_IMG, dim, naxis, &status);
    fits_write_2d_dbl(incidence_fptr, 0, naxis[0], naxis[0], naxis[1], incidence_img, &status);
    fits_close_file(incidence_fptr, &status);
    
    fits_create_img(emission_fptr, DOUBLE_IMG, dim, naxis, &status);
    fits_write_2d_dbl(emission_fptr, 0, naxis[0], naxis[0], naxis[1], emission_img, &status);
    fits_close_file(emission_fptr, &status);
    
    fits_create_img(phase_fptr, DOUBLE_IMG, dim, naxis, &status);
    fits_write_2d_dbl(phase_fptr, 0, naxis[0], naxis[0], naxis[1], phase_img, &status);
    fits_close_file(phase_fptr, &status);
    
    fits_create_img(lat_fptr, DOUBLE_IMG, dim, naxis, &status);
    fits_write_2d_dbl(lat_fptr, 0, naxis[0], naxis[0], naxis[1], lat_img, &status);
    fits_close_file(lat_fptr, &status);
    
    fits_create_img(lon_fptr, DOUBLE_IMG, dim, naxis, &status);
    fits_write_2d_dbl(lon_fptr, 0, naxis[0], naxis[0], naxis[1], lon_img, &status);
    fits_close_file(lon_fptr, &status);
    
    fits_create_img(albedo_fptr, DOUBLE_IMG, dim, naxis, &status);
    fits_write_2d_dbl(albedo_fptr, 0, naxis[0], naxis[0], naxis[1], albedo_img, &status);
    fits_close_file(albedo_fptr, &status);
    
    fits_create_img(hapke_fptr, DOUBLE_IMG, dim, naxis, &status);
    fits_write_2d_dbl(hapke_fptr, 0, naxis[0], naxis[0], naxis[1], hapke_img, &status);
    fits_close_file(hapke_fptr, &status);
    
    fits_create_img(strike_fptr, DOUBLE_IMG, dim, naxis, &status);
    fits_write_2d_dbl(strike_fptr, 0, naxis[0], naxis[0], naxis[1], strike_img, &status);
    fits_close_file(strike_fptr, &status);
    
  }
}
